// AI supports only en_US currently, later on locale should be passed 
// dynamically for feed statistics when AI is supports more locales
var ACFeedStatistics = Class.create({
	feedsurl: './index?page=feedstatistics',
	params: new Hash({model: modelValue, locale: 'en_US'}),
	store: new Persist.Store('FeedStats'),

	initialize: function(){
	},
	
	updateNotViewedForSuggestedSearch: function(searchText){
		if (this.store.get('lastQuerySuggestedSearch') !== searchText && this.store.get('resultActivity') == 'false' && this.store.get('sentNotViewed') == 'false'){
            var notviewedhash = new Hash(this.params);    
            notviewedhash.set('feedType', 'notviewed');
            notviewedhash.set('query', this.store.get('lastQuery'));
            this.store.set('sentNotViewed', true);
            this.sendRequest(notviewedhash);
        }
	},
	
	updateSearched: function(resultBool, query){ 
		if (this.store.get('lastQuery') !== null && this.store.get('resultActivity') == 'false' && this.store.get('sentNotViewed') == 'false'){
			this.updateNotViewed();
		}
		this.store.set('resultActivity', false);
        this.store.set('lastQuery', query);
		this.store.set('nextPage', false)
		var searchhash = new Hash(this.params);
		searchhash.set('feedType', 'searched');
		searchhash.set('hasResults', resultBool);
		searchhash.set('query', query);
		if(this.store.get('hasSuggestion') == 'true'){
			searchhash.set('lastSuggestions', encodeURI(this.store.get('lastSuggested')));
			this.store.set('hasSuggestion', 'false');
		}
		else if(this.store.get('hasSuggestedSuggestion') == 'true'){
			searchhash.set('lastSuggestions', encodeURI(this.store.get('lastSuggestedSearch')));
			this.store.set('hasSuggestedSuggestion', false);
		}
		else{
			searchhash.set('lastSuggestions', null);
		}
		this.sendRequest(searchhash);
        this.store.set('sentNotViewed', false);
	},
	
	updateNextPage: function(){ 
		if (this.store.get('nextPage')=='false'){
			var nexthash = new Hash(this.params);
			nexthash.set('feedType', 'nextpage');
			nexthash.set('query', this.store.get('lastQuery'));
			this.sendRequest(nexthash);
		}
		this.store.set('nextPage', true);
	},
	
	updateNotViewed: function(){ 
		if(this.store.get('searchDone') == 'false'){ 
			if (this.store.get('lastQuery') !== this.store.get('lastSuggestedQuery') && this.store.get('resultActivity') == 'false' && this.store.get('sentNotViewed') == 'false'){
            	var notviewedhash = new Hash(this.params);
            	notviewedhash.set('feedType', 'notviewed');
            	notviewedhash.set('query', this.store.get('lastSuggestedQuery'));
            	this.sendRequest(notviewedhash);
       		}
       	}
	},
	updateResultActivity: function(position){ 
		this.store.set('resultActivity', true);
		this.store.set('position', position);
	},
	
	updateNotRead: function(articleID, position){ 
		var notreadhash = new Hash(this.params);
		notreadhash.set('feedType', 'notread');
		notreadhash.set('articleID', articleID);
		notreadhash.set('query', this.store.get('lastQuery'));
		notreadhash.set('position', position);
		//this.sendRequest(notreadhash);
		this.sendSyncRequest(notreadhash);
	},
	
	updateRead: function(articleID, position){ 
		var readhash = new Hash(this.params);
		readhash.set('feedType', 'read');
		readhash.set('articleID', articleID);
		readhash.set('query', this.store.get('lastQuery'));
		readhash.set('position', position);
		this.sendRequest(readhash);
	},
	
	loadListeners: function(numArticles){ 
		try{
            var self = this;
			var resultLinks = $$('li.top-results a');
            for (var i=0; i<resultLinks.length; i++){   
                var position = numArticles-10+i;
				Event.observe(resultLinks[i], 'mousedown', function(event){  
					self.updateResultActivity(position);
                });
			}
		}
		catch(err){
			if(typeof console != 'undefined') console.log("Error: " + err);
		}
	},
	
	callbackSuccess: function(){
		if(typeof console != 'undefined') console.log("Send Successful");
	},
	
	callbackFailure: function(){ 
		if(typeof console != 'undefined') console.log("Send Failure");
	},
	
	sendRequest: function(params){  
		var url = this.feedsurl;
		var keyArray = params.keys();
		/*for(i=0;i<keyArray.length;i++){
			var key = keyArray[i];
			var value = params.get(key);
			url = url +"&"+key+"="+value;
		}*/
		new Ajax.Request(this.feedsurl, {method: 'get', parameters: params.toQueryString(), onSuccess: this.callbackSuccess, onFailure: this.callbackFailure});
		/*var langURL = url; 
		var dynamicScript = new JSONscriptRequest(langURL);
		if(dynamicScript.headLoc) {
			try{
				dynamicScript.buildScriptTag();
				dynamicScript.addScriptTag();
			}
			catch(ex) {
				// IE 5 for Mac will throw an exception here.
			}
		}*/			
	},
	
	sendSyncRequest: function(params){
		var http;
		   if (window.XMLHttpRequest) { // code for IE7+, FF, Chrome, Opera, Safari
		      http=new XMLHttpRequest();
		   }
		   else { // code for IE6, IE5
		      http=new ActiveXObject("Microsoft.XMLHTTP");
		   }
		   
		   var url = this.feedsurl;
		   var keyArray = params.keys();
		   for(i=0;i<keyArray.length;i++){
			   var key = keyArray[i];
			   var value = params.get(key);
			   url = url +"&"+key+"="+value;
		   }		   
		   http.open("GET", url, false);
		   http.send();
	}
});
